
-- Predicate logic

infixr 2 \/
infixr 3 /\
infixr 4 ==>

data Exist {A:Set}(P:A -> Prop) : Prop where
  witness : (x:A) -> P x -> Exist (\x -> P x)

data (/\)(P,Q:Prop) : Prop where
  andI : P -> Q -> P /\ Q

data (\/)(P,Q:Prop) : Prop where
  orIL : P -> P \/ Q
  orIR : Q -> P \/ Q

data True : Prop where
  tt : True

data False : Prop where

data (==>)(P,Q:Prop) : Prop where
  impI : (P -> Q) -> P ==> Q

falseE (A:Prop) : False -> A
falseE ()

Not : Prop -> Prop
Not P = P -> False

