
module Utils.UglyHack where

import Data.Map as Map
import Data.IORef
import System.IO.Unsafe

import Utils.Monads

setUglyHack :: String -> Int -> IO ()
getUglyHack :: String -> Int

(setUglyHack, getUglyHack) = unsafePerformIO $ do
    r <- newIORef Map.empty
    return ( \s v -> modifyIORef r $ Map.insert s v
	   , \s	  -> case unsafePerformIO $ Map.lookup s <$> readIORef r of
			Just n	-> n
			Nothing	-> error $ "No such ugly hack: " ++ s
	   )

